(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactAwesomeSocket = {}, global.React));
}(this, (function (exports, React) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = null != arguments[i] ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }

    return target;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get");

    return _classApplyDescriptorGet(receiver, descriptor);
  }

  function _classPrivateFieldSet(receiver, privateMap, value) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set");

    _classApplyDescriptorSet(receiver, descriptor, value);

    return value;
  }

  function _classExtractFieldDescriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
      throw new TypeError("attempted to " + action + " private field on non-instance");
    }

    return privateMap.get(receiver);
  }

  function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
      return descriptor.get.call(receiver);
    }

    return descriptor.value;
  }

  function _classApplyDescriptorSet(receiver, descriptor, value) {
    if (descriptor.set) {
      descriptor.set.call(receiver, value);
    } else {
      if (!descriptor.writable) {
        throw new TypeError("attempted to set read only private field");
      }

      descriptor.value = value;
    }
  }

  function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
      throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
  }

  function _classPrivateFieldInitSpec(obj, privateMap, value) {
    _checkPrivateRedeclaration(obj, privateMap);

    privateMap.set(obj, value);
  }

  var WebSocketEvent;

  (function (WebSocketEvent) {
    WebSocketEvent["OPEN"] = "open";
    WebSocketEvent["MESSAGE"] = "message";
    WebSocketEvent["ERROR"] = "error";
    WebSocketEvent["CLOSE"] = "close";
  })(WebSocketEvent || (WebSocketEvent = {}));

  var WebSocketState;

  (function (WebSocketState) {
    WebSocketState[WebSocketState["CONNECTING"] = 0] = "CONNECTING";
    WebSocketState[WebSocketState["OPEN"] = 1] = "OPEN";
    WebSocketState[WebSocketState["CLOSING"] = 2] = "CLOSING";
    WebSocketState[WebSocketState["CLOSED"] = 3] = "CLOSED";
  })(WebSocketState || (WebSocketState = {}));

  var WebSocketClosingCode;

  (function (WebSocketClosingCode) {
    WebSocketClosingCode[WebSocketClosingCode["FORCE_CLOSE"] = 1001] = "FORCE_CLOSE";
  })(WebSocketClosingCode || (WebSocketClosingCode = {}));

  var PREFIX = 'use-socket';

  var _prefix = /*#__PURE__*/new WeakMap();

  var LoggerService = /*#__PURE__*/_createClass(function LoggerService() {
    var _this = this;

    var prefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : PREFIX;

    _classCallCheck(this, LoggerService);

    _classPrivateFieldInitSpec(this, _prefix, {
      writable: true,
      value: void 0
    });

    this.log = function (message, data) {
      // eslint-disable-next-line no-console
      console.groupCollapsed("[".concat(_classPrivateFieldGet(_this, _prefix), "] ").concat(message)); // eslint-disable-next-line no-console

      data && console.log(data); // eslint-disable-next-line no-console

      console.groupEnd();
    };

    this.error = function (message, data) {
      // eslint-disable-next-line no-console
      console.error("[".concat(_classPrivateFieldGet(_this, _prefix), "] ").concat(message), data);
    };

    _classPrivateFieldSet(this, _prefix, prefix);
  });

  var _serializer = /*#__PURE__*/new WeakMap();

  var _deserializer = /*#__PURE__*/new WeakMap();

  var SerializerService = /*#__PURE__*/_createClass(function SerializerService(serializer, deserializer) {
    var _this = this;

    _classCallCheck(this, SerializerService);

    _classPrivateFieldInitSpec(this, _serializer, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _deserializer, {
      writable: true,
      value: void 0
    });

    this.serialize = function (data) {
      var _classPrivateFieldGet2;

      var serializedData = ((_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _serializer)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.call(_this, data)) || data;
      return typeof serializedData === 'string' ? serializedData : JSON.stringify(data);
    };

    this.deserialize = function (data) {
      var _classPrivateFieldGet3;

      return ((_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _deserializer)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.call(_this, data)) || data;
    };

    _classPrivateFieldSet(this, _serializer, serializer);

    _classPrivateFieldSet(this, _deserializer, deserializer);
  });

  var RandomService = /*#__PURE__*/_createClass(function RandomService() {
    _classCallCheck(this, RandomService);

    this.generateString = function () {
      return "".concat(Date.now().toString(36)).concat(Math.random().toString(36).slice(2));
    };
  });

  var _loggerService = /*#__PURE__*/new WeakMap();

  var _randomService = /*#__PURE__*/new WeakMap();

  var _listeners = /*#__PURE__*/new WeakMap();

  var _getListeners = /*#__PURE__*/new WeakMap();

  var SignalListenersService = /*#__PURE__*/_createClass(function SignalListenersService(debug) {
    var _this = this;

    _classCallCheck(this, SignalListenersService);

    _classPrivateFieldInitSpec(this, _loggerService, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _randomService, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _listeners, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _getListeners, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _listeners, []);

    this.add = function (indicator, listener) {
      var _classPrivateFieldGet2;

      var id = _classPrivateFieldGet(_this, _randomService).generateString();

      _classPrivateFieldSet(_this, _listeners, [].concat(_toConsumableArray(_classPrivateFieldGet(_this, _listeners)), [{
        id: id,
        indicator: indicator,
        listener: listener
      }]));

      (_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.log("Added listener for \"".concat(indicator, "\""), {
        id: id
      });
      return function () {
        return _this.remove(indicator, id);
      };
    };

    this.remove = function (indicator, id) {
      var _classPrivateFieldGet3;

      if (!_classPrivateFieldGet(_this, _listeners).length) return;

      _classPrivateFieldSet(_this, _listeners, _classPrivateFieldGet(_this, _listeners).filter(function (listener) {
        return listener.indicator === indicator && listener.id === id;
      }));

      (_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.log("Removed listener for \"".concat(indicator, "\""), {
        id: id
      });
    };

    this.ping = function (indicator, data, error) {
      var _classPrivateFieldGet4;

      var listeners = _classPrivateFieldGet(_this, _getListeners).call(_this, indicator);

      (_classPrivateFieldGet4 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.log(!(listeners !== null && listeners !== void 0 && listeners.length) ? 'Ignored (no listeners)' : 'Received', data);

      if (listeners.length) {
        listeners.forEach(function (_ref) {
          var listener = _ref.listener;
          listener(error, data);
        });
      }
    };

    _classPrivateFieldSet(this, _getListeners, function (indicator) {
      return _classPrivateFieldGet(_this, _listeners).filter(function (listener) {
        return listener.indicator === indicator;
      });
    });

    _classPrivateFieldSet(this, _randomService, new RandomService());

    if (debug) {
      _classPrivateFieldSet(this, _loggerService, new LoggerService());
    }
  });

  var _interval = /*#__PURE__*/new WeakMap();

  var _callback = /*#__PURE__*/new WeakMap();

  var _loggerService$1 = /*#__PURE__*/new WeakMap();

  var _reconnections = /*#__PURE__*/new WeakMap();

  var _timeout = /*#__PURE__*/new WeakMap();

  var _getInterval = /*#__PURE__*/new WeakMap();

  var _setReconnections = /*#__PURE__*/new WeakMap();

  var _incrementReconnections = /*#__PURE__*/new WeakMap();

  var _resetReconnections = /*#__PURE__*/new WeakMap();

  var ReconnectorService = /*#__PURE__*/_createClass(function ReconnectorService(callback) {
    var _this = this;

    var interval = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;
    var debug = arguments.length > 2 ? arguments[2] : undefined;

    _classCallCheck(this, ReconnectorService);

    _classPrivateFieldInitSpec(this, _interval, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _callback, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _loggerService$1, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _reconnections, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _timeout, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _getInterval, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _setReconnections, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _incrementReconnections, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _resetReconnections, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _reconnections, 0);

    _classPrivateFieldSet(this, _timeout, null);

    this.startJob = function () {
      var _classPrivateFieldGet2;

      var interval = _classPrivateFieldGet(_this, _getInterval).call(_this);

      (_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _loggerService$1)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.log('Disconnected. Reconnect in ${interval} milliseconds');

      _classPrivateFieldSet(_this, _timeout, setTimeout(_classPrivateFieldGet(_this, _callback), interval));

      _classPrivateFieldGet(_this, _incrementReconnections).call(_this);
    };

    this.removeJob = function () {
      clearTimeout(_classPrivateFieldGet(_this, _timeout));

      _classPrivateFieldSet(_this, _timeout, null);

      _classPrivateFieldGet(_this, _resetReconnections).call(_this);
    };

    _classPrivateFieldSet(this, _getInterval, function () {
      var interval = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(_this, _interval);
      if (typeof interval === 'number') return interval;
      if (interval.length) return 0;
      var lastIntervalsIdx = interval.length - 1;

      if (_classPrivateFieldGet(_this, _reconnections) <= lastIntervalsIdx) {
        return interval[_classPrivateFieldGet(_this, _reconnections)];
      }

      return interval[lastIntervalsIdx];
    });

    _classPrivateFieldSet(this, _setReconnections, function (value) {
      _classPrivateFieldSet(_this, _reconnections, value);
    });

    _classPrivateFieldSet(this, _incrementReconnections, function () {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(_this, _reconnections);

      _classPrivateFieldGet(_this, _setReconnections).call(_this, start + 1);
    });

    _classPrivateFieldSet(this, _resetReconnections, function () {
      _classPrivateFieldGet(_this, _setReconnections).call(_this, 0);
    });

    _classPrivateFieldSet(this, _interval, interval);

    _classPrivateFieldSet(this, _callback, callback);

    if (debug) {
      _classPrivateFieldSet(this, _loggerService$1, new LoggerService());
    }
  });

  var _excluded = ["shouldReconnect", "reconnectionInterval", "serialize", "deserialize", "debug"];

  var _options = /*#__PURE__*/new WeakMap();

  var _shouldReconnect = /*#__PURE__*/new WeakMap();

  var _openCallback = /*#__PURE__*/new WeakMap();

  var _closeCallback = /*#__PURE__*/new WeakMap();

  var _loggerService$2 = /*#__PURE__*/new WeakMap();

  var _reconnectorService = /*#__PURE__*/new WeakMap();

  var _signalListenersService = /*#__PURE__*/new WeakMap();

  var _serializerService = /*#__PURE__*/new WeakMap();

  var _ws = /*#__PURE__*/new WeakMap();

  var _setListeners = /*#__PURE__*/new WeakMap();

  var _removeListeners = /*#__PURE__*/new WeakMap();

  var _handleOpen = /*#__PURE__*/new WeakMap();

  var _handleMessage = /*#__PURE__*/new WeakMap();

  var _handleError = /*#__PURE__*/new WeakMap();

  var _handleClose = /*#__PURE__*/new WeakMap();

  var _checkOpenStateAndThrowError = /*#__PURE__*/new WeakMap();

  var WebSocketService = /*#__PURE__*/_createClass(function WebSocketService(options, openCallback, closeCallback) {
    var _this = this;

    _classCallCheck(this, WebSocketService);

    _classPrivateFieldInitSpec(this, _options, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _shouldReconnect, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _openCallback, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _closeCallback, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _loggerService$2, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _reconnectorService, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _signalListenersService, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _serializerService, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _ws, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _setListeners, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _removeListeners, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _handleOpen, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _handleMessage, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _handleError, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _handleClose, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _checkOpenStateAndThrowError, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _ws, null);
    /*
     * WS Instance State Managers
     */


    this.open = function () {
      var _classPrivateFieldGet2 = _classPrivateFieldGet(_this, _options),
          url = _classPrivateFieldGet2.url,
          protocols = _classPrivateFieldGet2.protocols;

      if (typeof window === 'undefined') return;

      _classPrivateFieldSet(_this, _ws, new WebSocket(url, protocols));

      _classPrivateFieldGet(_this, _setListeners).call(_this);
    };

    this.send = function (data) {
      var _classPrivateFieldGet3;

      _classPrivateFieldGet(_this, _checkOpenStateAndThrowError).call(_this);

      var message = _classPrivateFieldGet(_this, _serializerService).serialize(data);

      _classPrivateFieldGet(_this, _ws).send(message);

      (_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _loggerService$2)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.log('Sent', message);
    };

    this.close = function (code) {
      _classPrivateFieldGet(_this, _checkOpenStateAndThrowError).call(_this);

      _classPrivateFieldGet(_this, _ws).close(code);

      _classPrivateFieldGet(_this, _removeListeners).call(_this);

      _classPrivateFieldSet(_this, _ws, null);
    };
    /*
     * Signal Listeners Managers
     */


    this.addSignalListener = function (indicator, listener) {
      return _classPrivateFieldGet(_this, _signalListenersService).add(indicator, listener);
    };

    this.removeSignalListener = function (indicator, id) {
      _classPrivateFieldGet(_this, _signalListenersService).remove(indicator, id);
    };
    /*
     * Event Listeners Managers
     */


    _classPrivateFieldSet(this, _setListeners, function () {
      if (!_classPrivateFieldGet(_this, _ws)) return;

      _classPrivateFieldGet(_this, _ws).addEventListener(WebSocketEvent.OPEN, _classPrivateFieldGet(_this, _handleOpen));

      _classPrivateFieldGet(_this, _ws).addEventListener(WebSocketEvent.MESSAGE, _classPrivateFieldGet(_this, _handleMessage));

      _classPrivateFieldGet(_this, _ws).addEventListener(WebSocketEvent.ERROR, _classPrivateFieldGet(_this, _handleError));

      _classPrivateFieldGet(_this, _ws).addEventListener(WebSocketEvent.CLOSE, _classPrivateFieldGet(_this, _handleClose));
    });

    _classPrivateFieldSet(this, _removeListeners, function () {
      if (!_classPrivateFieldGet(_this, _ws)) return;

      _classPrivateFieldGet(_this, _ws).removeEventListener(WebSocketEvent.OPEN, _classPrivateFieldGet(_this, _handleOpen));

      _classPrivateFieldGet(_this, _ws).removeEventListener(WebSocketEvent.MESSAGE, _classPrivateFieldGet(_this, _handleMessage));

      _classPrivateFieldGet(_this, _ws).removeEventListener(WebSocketEvent.ERROR, _classPrivateFieldGet(_this, _handleError));

      _classPrivateFieldGet(_this, _ws).removeEventListener(WebSocketEvent.CLOSE, _classPrivateFieldGet(_this, _handleClose));
    });
    /*
     * Event Handlers
     */


    _classPrivateFieldSet(this, _handleOpen, function (event) {
      var _classPrivateFieldGet4, _classPrivateFieldGet5;

      (_classPrivateFieldGet4 = _classPrivateFieldGet(_this, _loggerService$2)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.log('Connected');
      (_classPrivateFieldGet5 = _classPrivateFieldGet(_this, _openCallback)) === null || _classPrivateFieldGet5 === void 0 ? void 0 : _classPrivateFieldGet5.call(_this, event);

      _classPrivateFieldGet(_this, _reconnectorService).removeJob();
    });

    _classPrivateFieldSet(this, _handleMessage, function (event) {
      var parsedData = JSON.parse(event.data);

      var data = _classPrivateFieldGet(_this, _serializerService).deserialize(event.data);

      var indicator = _classPrivateFieldGet(_this, _options).getResponseIndicator(parsedData);

      var error = _classPrivateFieldGet(_this, _options).getError(parsedData);

      _classPrivateFieldGet(_this, _signalListenersService).ping(indicator, data, error);
    });

    _classPrivateFieldSet(this, _handleError, function (event) {
      var _classPrivateFieldGet6;

      (_classPrivateFieldGet6 = _classPrivateFieldGet(_this, _loggerService$2)) === null || _classPrivateFieldGet6 === void 0 ? void 0 : _classPrivateFieldGet6.error('Error', event);
    });

    _classPrivateFieldSet(this, _handleClose, function (event) {
      var _classPrivateFieldGet7;

      (_classPrivateFieldGet7 = _classPrivateFieldGet(_this, _closeCallback)) === null || _classPrivateFieldGet7 === void 0 ? void 0 : _classPrivateFieldGet7.call(_this, event);
      var code = event.code,
          reason = event.reason;
      var forceDisconnection = code === WebSocketClosingCode.FORCE_CLOSE;

      if (forceDisconnection && typeof _classPrivateFieldGet(_this, _shouldReconnect) === 'boolean') {
        var _classPrivateFieldGet8;

        (_classPrivateFieldGet8 = _classPrivateFieldGet(_this, _loggerService$2)) === null || _classPrivateFieldGet8 === void 0 ? void 0 : _classPrivateFieldGet8.log('Disconnected', {
          code: code,
          reason: reason
        });
        return;
      } else if (typeof _classPrivateFieldGet(_this, _shouldReconnect) === 'boolean') {
        _classPrivateFieldGet(_this, _reconnectorService).startJob();

        return;
      }

      if (_classPrivateFieldGet(_this, _shouldReconnect).call(_this, event)) {
        _classPrivateFieldGet(_this, _reconnectorService).startJob();
      }
    });
    /*
     * Throwing Error Checkers
     */


    _classPrivateFieldSet(this, _checkOpenStateAndThrowError, function () {
      if (_classPrivateFieldGet(_this, _ws) && _classPrivateFieldGet(_this, _ws).readyState === WebSocketState.OPEN) return;
      throw new Error('WebSocket is not connected. Make sure it is connected before triggering an action.');
    });

    var shouldReconnect = options.shouldReconnect,
        reconnectionInterval = options.reconnectionInterval,
        serialize = options.serialize,
        deserialize = options.deserialize,
        debug = options.debug,
        restOptions = _objectWithoutProperties(options, _excluded);

    _classPrivateFieldSet(this, _options, restOptions);

    _classPrivateFieldSet(this, _shouldReconnect, shouldReconnect !== null && shouldReconnect !== void 0 ? shouldReconnect : true);

    _classPrivateFieldSet(this, _openCallback, openCallback);

    _classPrivateFieldSet(this, _closeCallback, closeCallback);

    _classPrivateFieldSet(this, _serializerService, new SerializerService(serialize, deserialize));

    _classPrivateFieldSet(this, _signalListenersService, new SignalListenersService(debug));

    _classPrivateFieldSet(this, _reconnectorService, new ReconnectorService(this.open, reconnectionInterval, debug));

    if (debug) {
      _classPrivateFieldSet(this, _loggerService$2, new LoggerService());

      _classPrivateFieldGet(this, _loggerService$2).log('Debug mode is ON', _classPrivateFieldGet(this, _options));
    }
  });

  var WebSocketContext = React.createContext({
    connected: false,
    open: function open() {},
    send: function send(_) {},
    close: function close() {},
    removeSignalListener: function removeSignalListener(_) {},
    addSignalListener: function addSignalListener(_, __) {
      return function () {};
    },
    getRequestSignalIndicator: function getRequestSignalIndicator(_) {
      return '';
    }
  });
  var WebSocketProvider = function WebSocketProvider(_ref) {
    var options = _ref.options,
        children = _ref.children;

    var _useState = React.useState(false),
        _useState2 = _slicedToArray(_useState, 2),
        connected = _useState2[0],
        setConnected = _useState2[1];

    var handleOpen = React.useCallback(function () {
      setConnected(true);
    }, []);
    var handleClose = React.useCallback(function () {
      setConnected(false);
    }, []);
    var webSocket = React.useMemo(function () {
      return new WebSocketService(options, handleOpen, handleClose);
    }, []);
    React.useEffect(function () {
      // This "false" check is required here since the value can be "undefined".
      // The socket needs to be connected when "undefined".
      if (options.autoConnect === false) return;
      webSocket.open();
    }, []);
    var open = React.useCallback(webSocket.open, []);
    var send = React.useCallback(webSocket.send, []);
    var close = React.useCallback(webSocket.close, []);
    var addSignalListener = React.useCallback(webSocket.addSignalListener, []);
    var removeSignalListener = React.useCallback(webSocket.removeSignalListener, []);
    return React__default['default'].createElement(WebSocketContext.Provider, {
      value: {
        connected: connected,
        open: open,
        send: send,
        close: close,
        addSignalListener: addSignalListener,
        removeSignalListener: removeSignalListener,
        getRequestSignalIndicator: options.getRequestSignalIndicator
      }
    }, children);
  };
  var useWebSocketContext = function useWebSocketContext() {
    var context = React.useContext(WebSocketContext);
    if (!context) throw new Error('WebSocket context not found. Make sure you use hooks inside a <WebSocketProvider>');
    return context;
  };

  var useWebSocketState = function useWebSocketState() {
    var _useWebSocketContext = useWebSocketContext(),
        connected = _useWebSocketContext.connected,
        open = _useWebSocketContext.open,
        close = _useWebSocketContext.close;

    return [connected, {
      open: open,
      close: close
    }];
  };

  var initialState = {
    mounted: false,
    loading: false,
    error: null,
    data: null
  };
  var useSignal = function useSignal(req) {
    var _useWebSocketContext = useWebSocketContext(),
        send = _useWebSocketContext.send,
        addSignalListener = _useWebSocketContext.addSignalListener,
        getRequestSignalIndicator = _useWebSocketContext.getRequestSignalIndicator,
        connected = _useWebSocketContext.connected;

    var removeListener = React.useRef(null);

    var _useState = React.useState(initialState),
        _useState2 = _slicedToArray(_useState, 2),
        state = _useState2[0],
        setState = _useState2[1];

    var sendRequest = React.useCallback(function () {
      if (!connected || state.mounted) return;
      setState(function (prevState) {
        return _objectSpread2(_objectSpread2({}, prevState), {}, {
          mounted: true,
          loading: true,
          error: null
        });
      });
      send(req);
    }, [req, connected, state.mounted]);
    React.useEffect(sendRequest, [connected]);
    React.useEffect(function () {
      var signal = getRequestSignalIndicator(req);
      removeListener.current = addSignalListener(signal, function (error, response) {
        setState(function (prevState) {
          return _objectSpread2(_objectSpread2({}, prevState), {}, {
            error: error,
            loading: false,
            data: response
          });
        });
      });
      return removeListener.current;
    }, []);
    return state;
  };
  var useLazySignal = function useLazySignal() {
    var _useWebSocketContext2 = useWebSocketContext(),
        send = _useWebSocketContext2.send,
        addSignalListener = _useWebSocketContext2.addSignalListener,
        getRequestSignalIndicator = _useWebSocketContext2.getRequestSignalIndicator;

    var signalIndicator = React.useRef(null);
    var removeListener = React.useRef(null);

    var _useState3 = React.useState(initialState),
        _useState4 = _slicedToArray(_useState3, 2),
        state = _useState4[0],
        setState = _useState4[1];

    var sendRequest = React.useCallback(function (req) {
      signalIndicator.current = getRequestSignalIndicator(req);
      setState(function (prevState) {
        return _objectSpread2(_objectSpread2({}, prevState), {}, {
          mounted: true,
          loading: true,
          error: null
        });
      });
      send(req);
    }, []);
    React.useEffect(function () {
      if (!signalIndicator.current) return;
      removeListener.current = addSignalListener(signalIndicator.current, function (error, response) {
        setState(function (prevState) {
          return _objectSpread2(_objectSpread2({}, prevState), {}, {
            loading: false,
            data: response,
            error: error
          });
        });
      });
    }, []);
    React.useEffect(function () {
      return function () {
        var _removeListener$curre;

        (_removeListener$curre = removeListener.current) === null || _removeListener$curre === void 0 ? void 0 : _removeListener$curre.call(removeListener);
      };
    }, []);
    return [state, {
      send: sendRequest
    }];
  };

  var initialState$1 = {
    data: null,
    error: null
  };
  var useSubscription = function useSubscription(signal) {
    var _useWebSocketContext = useWebSocketContext(),
        addSignalListener = _useWebSocketContext.addSignalListener;

    var removeListener = React.useRef(null);

    var _useState = React.useState(initialState$1),
        _useState2 = _slicedToArray(_useState, 2),
        state = _useState2[0],
        setState = _useState2[1];

    React.useEffect(function () {
      removeListener.current = addSignalListener(signal, function (error, response) {
        setState({
          error: error,
          data: response
        });
      });
      return removeListener.current;
    }, []);
    var stop = React.useCallback(function () {
      var _removeListener$curre;

      (_removeListener$curre = removeListener.current) === null || _removeListener$curre === void 0 ? void 0 : _removeListener$curre.call(removeListener);
    }, []);
    return [state, {
      stop: stop
    }];
  };
  var useLazySubscription = function useLazySubscription(signal) {
    var _useWebSocketContext2 = useWebSocketContext(),
        addSignalListener = _useWebSocketContext2.addSignalListener;

    var removeListener = React.useRef(null);

    var _useState3 = React.useState(initialState$1),
        _useState4 = _slicedToArray(_useState3, 2),
        state = _useState4[0],
        setState = _useState4[1];

    React.useEffect(function () {
      return function () {
        var _removeListener$curre2;

        (_removeListener$curre2 = removeListener.current) === null || _removeListener$curre2 === void 0 ? void 0 : _removeListener$curre2.call(removeListener);
      };
    }, []);
    var start = React.useCallback(function () {
      removeListener.current = addSignalListener(signal, function (error, response) {
        setState({
          error: error,
          data: response
        });
      });
    }, []);
    var stop = React.useCallback(function () {
      var _removeListener$curre3;

      (_removeListener$curre3 = removeListener.current) === null || _removeListener$curre3 === void 0 ? void 0 : _removeListener$curre3.call(removeListener);
    }, []);
    return [state, {
      start: start,
      stop: stop
    }];
  };

  exports.WebSocketProvider = WebSocketProvider;
  exports.useLazySignal = useLazySignal;
  exports.useLazySubscription = useLazySubscription;
  exports.useSignal = useSignal;
  exports.useSubscription = useSubscription;
  exports.useWebSocketState = useWebSocketState;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=react-use-socket.development.js.map
